#include "p1.h"

/**************************************************
  A DPDW GENERATED BY nsrcs SOURCES AND
  SCATTERED BY nobjs OBJECTS WITH nplanes 
  PLANAR FREE SPACE BOUNDARIES AND DETECTED BY
  ndets DETECTORS


COPYRIGHT:
     Copyright 1994 by David Boas (boas@sol1.lrsm.upenn.edu)

     Permission to use, copy, modify, and distribute this
     software and its documentation for any purpose and without
     fee is hereby granted, provided that the above copyright
     notice appear in all copies.  The University of Pennsylvania
     makes no representations about the suitability of this
     software for any purpose.  It is provided "as is" without
     express or implied warranty.

DISCLAIMER:
     UNDER NO CIRCUMSTANCES WILL THE AUTHOR OF THIS SOFTWARE OR THE
     UNIVERSITY OF PENNSYLVANIA BE RESPONSIBLE FOR ANY DIRECT OR
     INCIDENTAL DAMAGE ARISING FROM THE USE OF THIS SOFTWARE AND ITS
     DOCUMENTATION. THE SOFTWARE HEREIN IS PROVIDED "AS IS" WITH NO
     IMPLIED OBLIGATION TO PROVIDE SUPPORT, UPDATES, OR MODIFICATIONS.
**************************************************/
dcomplex image;
dcomplex DPDW(rd,rs,ro,rb,ko,ki,a,uai,uinc,usc,nsrcs,ndets,nobjs,nplanes)
dcomplex ko,*ki,*uinc,*usc;
VECTOR *ro,*rb;
SOURCE *rs,*rd;
double *a,*uai;
int nsrcs,ndets,nobjs;
{
  double amp_o;
  int i, j, srcplane;

  image = Complex( 1.0, 0.0 );
  srcplane = 0;
  *usc = Complex(0.,0.);
  *uinc = Complex(0.,0.);
  amp_o = 0.;

/*CALCULATE INCIDENT WAVE*/
  for( i=0; i<nsrcs; i++ )
    for( j=0; j<ndets; j++ )
      Calculate_Uinc(rd[j],rs[i],rb,ko,amp_o,uinc,srcplane,nplanes);
  *uinc = RCmul( 1./(v*Do), *uinc );

/*CHECK IF INSIDE AN OBJECT*/
  for( i=0; i<nobjs; i++ )
    for( j=0; j<ndets; j++ )
      if( length(rd[j].x-ro[i].x,rd[j].y-ro[i].y,rd[j].z-ro[i].z)<a[i] ) return Complex(9999.,9999.);

/*CALCULATE THE SCATTERED WAVE*/
  for( i=0; i<nsrcs; i++ )
    for( j=0; j<ndets; j++ )
      LoopObjects(rd[j],rs[i],ro,rb,ko,ki,a,uai,usc,srcplane,nobjs,nplanes);
  *usc = RCmul( 1./(v*Do), *usc );

  return Cadd(*uinc,*usc);
}

Calculate_Uinc(rd,rs,rb,ko,amp_o,uinc,srcplane,nplanes)
dcomplex ko,*uinc;
VECTOR *rb;
SOURCE rs,rd;
double amp_o;
int nplanes;
{
  dcomplex uadd;
  double rsd,temp;
  int i;

  rsd = length(rd.x-rs.x, rd.y-rs.y, rd.z-rs.z);
  uadd = Cmul(image,Cmul(Cmul(rs.s,rd.s),Inc(ko,rsd)));

  if( amp_o==0 )  amp_o = Cabs(uadd);
  temp = Cabs(uadd)/amp_o;
  if( temp > tollerence )
    {
      *uinc=Cadd(*uinc,uadd);
      for( i=1; i<=nplanes; i++ )
	if( i!=srcplane )
	  {
	    image.r*=-1.0;
	    rs.z = rb[i].z - (rs.z - rb[i].z);
	    Calculate_Uinc(rd,rs,rb,ko,amp_o,uinc,i,nplanes);
	    rs.z = rb[i].z - (rs.z - rb[i].z);
	    image.r*=-1.0;
	  }
    }
}

LoopObjects(rd,rs,ro,rb,ko,ki,a,uai,usc,srcplane,nobjs,nplanes)
dcomplex ko,*ki,*usc;
VECTOR *ro,*rb;
SOURCE rs,rd;
double *a,*uai;
int srcplane,nobjs,nplanes;
{
  double amp_o;
  int i,objplane,flag;

  flag = 0;
  amp_o = 0.;

/*LOOP OVER OBJECTS*/
  for( i=0; i<nobjs; i++ )
    {
      objplane = 0;
      obj_num = i;
      Calculate_Usc(rd,rs,ro[i],rb,ko,ki[i],a[i],uai[i],amp_o,usc,objplane,nplanes,&flag);
    }

/*REFLECT SOURCE IF NECESSARY*/
  if( flag )
    for( i=1; i<=nplanes; i++ )
      if( i!=srcplane )
	{
	  image.r*=-1.0;
	  rs.z = rb[i].z - (rs.z - rb[i].z);
	  LoopObjects(rd,rs,ro,rb,ko,ki,a,uai,usc,i,nobjs,nplanes);
	  rs.z = rb[i].z - (rs.z - rb[i].z);
	  image.r*=-1.0;
	}
}

Calculate_Usc(rd,rs,ro,rb,ko,ki,a,uai,amp_o,usc,objplane,nplanes,flag)
dcomplex ko,ki,*usc;
VECTOR ro,*rb;
SOURCE rs,rd;
double a,uai,amp_o;
int objplane,nplanes,*flag;
{
  dcomplex uadd, kocyl2, kicyl2;
  double rsd, rso, rod, theta, temp;
  int i;

/*CALCULATE USC*/
  rsd = length(rd.x-rs.x, rd.y-rs.y, rd.z-rs.z);
  rso = length(ro.x-rs.x, ro.y-rs.y, ro.z-rs.z);
  rod = length(rd.x-ro.x, rd.y-ro.y, rd.z-ro.z);
  temp = (rsd*rsd - rso*rso - rod*rod)/(2.*rso*rod);
  if( fabs(temp)>1.0 ) temp=1.0;
  theta = acos( temp );

  if( obj_type==CYLINDER ) {
    kocyl2 = RCmul(-1.,Cmul(ko,ko));
    kicyl2 = RCmul(-1.,Cmul(ki,ki));
    if( uai>AB )  uadd = Cmul(image,Cmul(Cmul(rs.s,rd.s),ScCylAbs( kocyl2, rod, pi-theta, rd.z-rs.z, rso, a )));
    else uadd = Cmul(image,Cmul(Cmul(rs.s,rd.s),ScCylDisp( kocyl2, kicyl2, rod, theta, rso, a )));
  }

  if( obj_type==SPHERE )
    if( uai>AB )  
      uadd = Cmul(image,Cmul(Cmul(rs.s,rd.s),ScSphAbs2( ko, rod, theta, rso, a )));
    else 
      uadd = Cmul(image,Cmul(Cmul(rs.s,rd.s),ScSphDisp( ko, ki, rod, theta, rso, a )));

  if( amp_o==0 )  amp_o = Cabs(uadd);
  if( Cabs(uadd)/amp_o > tollerence )
    {
      *flag = 1;
      *usc = Cadd(*usc,uadd);
      /*REFLECT OBJECT IF NECESSARY*/
      for( i=1; i<=nplanes; i++ )
	if( i!=objplane )
	  {
	    image.r*=-1.0;
	    rs.z = rb[i].z - (rs.z-rb[i].z);
	    ro.z = rb[i].z - (ro.z-rb[i].z);
	    Calculate_Usc(rd,rs,ro,rb,ko,ki,a,uai,amp_o,usc,i,nplanes,flag);
	    ro.z = rb[i].z - (ro.z-rb[i].z);
	    rs.z = rb[i].z - (rs.z-rb[i].z);
	    image.r*=-1.0;
	  }
    } 
}





/**********************************************
RETURN THE DISTANCE BETWEEN TWO POINTS
**********************************************/
double length( x, y, z )
double x, y, z;
{
  return sqrt(x*x+y*y+ z*z);
}


