#include <stdio.h>
#include <math.h>

#define tollerence 1.e-10
#define pi 3.141592654

#define SPHERE   1
#define CYLINDER 2

#define AB       10         /*ABSORBER THRESHOLD*/

#define NOBJS    10         /*MAX NUMBER OF OBJECTS*/
#define NSRCS    10         /*MAX NUMBER OF SOURCES*/
#define NPLANES  10         /*MAX NUMBER OF PLANES*/

typedef struct DCOMPLEX {double r,i;} dcomplex;

typedef struct {
  double x, y, z;
} VECTOR;

typedef struct {
  double x, y, z;
  dcomplex s;              /*INITIAL AMP AND PHASE OF SOURCE*/
} SOURCE;

dcomplex DPDW( );
double length();

dcomplex FSD( );
dcomplex Inc( );
dcomplex ScSphAbs( );
dcomplex ScSphAbs2( );
dcomplex ScSphAbs2_coeff( );
dcomplex ScSphAbs2_coeff_1( );
dcomplex ScSphDisp( );
dcomplex ScSphDisp_coeff( );
dcomplex ScSphDisp_coeff_1( );
dcomplex ScCylAbs( );
dcomplex ScCylAbs2( );
dcomplex ScCylDisp( );

dcomplex SphBesselJ( );
dcomplex SphBesselH( );
dcomplex DSphBesselJ( );
dcomplex DSphBesselH( );
dcomplex CBessI( );
dcomplex CDBessI( );
dcomplex CBessK( );
dcomplex CDBessK( );

dcomplex Complex( );
dcomplex Cadd( );
dcomplex Csub( );
dcomplex Cmul( );
dcomplex RCmul( );
dcomplex Cdiv( );
dcomplex Csqrt( );
double Cabs( );

dcomplex SphHarmonic( );
dcomplex Cexp( );
dcomplex Ccos( );
dcomplex Csin( );
dcomplex Clog( );

double Di[NOBJS], Do, v;
int obj_type, obj_num;
