#include "p1.h"

#define trs_tollerence  10e-8
#define NBINS 100
#define NCOMP 2000
#define MAXITER 500

main()
{
  dcomplex u[NCOMP], uinc, usc, k, ki[NOBJS], pp;
  double amp_sp[NCOMP], ph_sp[NCOMP];
  double amp_inc[NCOMP], ph_inc[NCOMP];
  double amp, amp_o;
  double us, ua, usi[NOBJS], uai[NOBJS], w, ww, freq;
  double kmag, karg;
  double a[NOBJS];
  double Zb, s;
  VECTOR ro[NOBJS], rb[NPLANES];
  SOURCE rs[NSRCS], rd[NSRCS];
  double tp, tw, t, tstep, tmax, p;
  int i, j, nw, nsrcs, ndets, nobjs, nplanes;
  char filenm[64], filetemp[74];
  FILE *fp_trs, *fp_spectrum;

/*EXPERIMENTAL PARAMETERS*/
  nsrcs = 1;
  ndets = 1;
  printf( "Us' and Ua:");
  scanf( "%lf %lf", &us, &ua);
  Zb = 1./us;

  obj_type = SPHERE;
  printf( "Number of Objects, number of planes:" );
  scanf( "%d %d", &nobjs, &nplanes );
  if( nsrcs>=NSRCS || ndets>=NSRCS || nobjs>=NOBJS || nplanes>=NPLANES ) {
    printf( "Must change maximum number of allowed\n" );
    printf( "sources, detectors, objects, or planes\n" );
    exit(1);
  }

  for( i=0; i<nobjs; i++ ) {
    printf( "Object %d) Xo Yo Zo a:", i+1);
    scanf( "%lf %lf %lf %lf", &ro[i].x, &ro[i].y, &ro[i].z, &a );
    printf( "Object %d) Us' and Ua:", i+1 );
    scanf( "%lf %lf", &usi[i], &uai[i]);
    Di[i] = 1/( 3*(usi[i]+uai[i]) );
  }

  printf( "Pulse Period:" );
  scanf( "%lf", &tp );
  printf( "Pulse Width:" );
  scanf( "%lf", &tw );
  printf( "Tmax:" );
  scanf( "%lf", &tmax );
  tstep = tmax/NBINS;
  v = 3.0e10 / 1.333;
  Do = 1/( 3*(us+ua) );
  ww = 2.0 * pi / tp;

/*OUTPUT FILE INFORMATION*/
  printf( "Xs, Ys, Zs of source:" );
  scanf( "%lf %lf %lf", &rs[0].x, &rs[0].y, &rs[0].z );
  rs[0].s = Complex(1.,0.);
  printf( "Xd, Yd, Zd of detector:" );
  scanf( "%lf %lf %lf", &rd[0].x, &rd[0].y, &rd[0].z );
  rd[0].s = Complex(1.,0.);
  printf( "Output filename excluding extension:" );
  scanf( "%s", filenm );

/*EXTRAPOLATED ZERO BOUNDARIES*/
  for( i=0; i<nplanes; i++ ) {
    printf( "Y of planar boundary %d and direction to air(+1/-1):", i+1 );
    scanf( "%lf %lf", &rb[i+1].y, &s );
    rb[i+1].y += Zb*s/fabs(s);
  }


/*OPEN FILES*/
  sprintf( filetemp, "%s.spectrum", filenm );
  fp_spectrum = fopen( filetemp, "w" );

  sprintf( filetemp, "%s.trs", filenm );
  fp_trs = fopen( filetemp, "w" );
  fprintf( fp_trs, "%d\n", NBINS-1 );

/***********************/
/*MAIN CALCULATION LOOP*/
/***********************/
  amp_o = 1.;
  amp = 1.;
  i = 0;
  while( amp/amp_o > trs_tollerence && i<MAXITER )
    {
      i++;
      w = (double)(i-1) * ww;

/*CALCULATION OF COMPLEX WAVENUMBER*/
      kmag = sqrt( sqrt( (v*v*ua*ua + w*w) / (v*v*Do*Do) ));
      karg = .5 * atan( w/(v*ua) );
      k = Cmul( Complex(kmag,0.0), Complex(sin(karg),cos(karg)) );

      for( j=0; j<nobjs; j++ ) {
	kmag = sqrt( sqrt( (v*v*uai[j]*uai[j] + w*w) / (v*v*Di[j]*Di[j]) ));
	karg = .5 * atan( w/(v*uai[j]) );
	ki[j] = Cmul( Complex(kmag,0.0), Complex(sin(karg),cos(karg)) );
      }

      u[i]=DPDW(rd,rs,ro,rb,k,ki,a,uai,&uinc,&usc,nsrcs,ndets,nobjs,nplanes);

      amp_inc[i] = Cabs( uinc );
      ph_inc[i] = atan2(uinc.i,uinc.r)*180./pi;

      amp = Cabs(u[i]);
      if( i==1 )  amp_o = amp;
      amp_sp[i] = amp;
      ph_sp[i] = atan2(u[i].i,u[i].r)*180./pi;
    }
  printf( "%d\n", i );
  nw = i;

  if( nw>NCOMP )
    {
      printf("This calculation is boogus because there are too many freq. components\n" );
      exit(1);
    }

/*SAVE THE SPECTRUM*/
  freq = ww/(2.*pi);
  fprintf( fp_spectrum, "Xs=%5.2lf Ys=%5.2lf Zs=%5.2lf\n", rs[0].x, rs[0].y, rs[0].x );
  fprintf( fp_spectrum, "Xd=%5.2lf Yd=%5.2lf Zd=%5.2lf\n", rd[0].x, rd[0].y, rd[0].x );
  fprintf( fp_spectrum, "us'=%5.2lf ua=%5.2lf\n", us, ua );
  for( i=0; i<nobjs; i++ ) {
    fprintf( fp_spectrum, "%d) Xo=%5.2lf Yo=%5.2lf Zo=%5.2lf ", i+1, ro[0].x, ro[0].y, ro[0].x );
    fprintf( fp_spectrum, "us'=%5.2lf ua=%5.2lf\n", usi[i], uai[i],
	    a[i] );
  }
  for( i=nobjs; i<5; i++ )  fprintf( fp_spectrum, " \n" );
  fprintf( fp_spectrum, "%d\n", nw );
  for( i=1; i<=nw; i++ )
    fprintf( fp_spectrum, "%e\t%e\t%e\n", (double)(i-1)*freq, amp_sp[i]/amp_inc[i], ph_sp[i]-ph_inc[i] );

/*TIME DOMAIN CALCULATION*/
  for( j=1; j<NBINS; j++ ) 
    {
      t=(double)j*tstep;
      p = 0;
      pp.r = 0;
      pp.i = 0;
      for( i=2; i<=nw; i++ )
	{
	  w = -1.0 * (double)(i-1) * ww;
	  pp = Cadd( pp, Cmul(u[i],Cmul(Complex(2.0,0.0),Cexp(Complex(0.0,w*t)))) );
	}
      pp = Cadd( pp, u[1] );
      p = -1000.0;
      if( pp.r>0 ) p = log( pp.r*sqrt(1./tp) );
      fprintf( fp_trs, "%e\t%e\n", t, p );
    }

/*CLOSE FILES*/
  fclose( fp_spectrum );
  fclose( fp_trs );
}

